const shell = require('node-powershell');



module.exports = function(RED) {
    function PowershellNode(config) {
        RED.nodes.createNode(this, config);
        let ps = new shell({
            executionPolicy: 'Bypass',
            noProfile: true,
            pwsh: true
        });

        this.on('input', function(msg) {
            ps.addCommand(msg.payload);
            ps.invoke()
            .then(output => {
                msg.payload = output;
                this.send(msg);
            })
            .catch(error => {
                msg.payload = error;
                this.error(error, msg);
            });
        });

        this.on('close', function() {

            ps.dispose();
        })
    }



    RED.nodes.registerType("powershell", PowershellNode);
}
